JUMPS
SMART
MutLen   Equ 0BDh                 ; Maximum mutations length
MinLen   Equ (MutLen-50h)         ; Minimum mutations length
BKey     Equ 0BADEEDDAh           ; The boundschecker encoding key
Ver      Equ '1.31'               ; Version string
HiVer    Equ 01
LoVer    Equ 31
Debuger  Equ 14
;TestMd  Equ 1                    ; This allows you to test anti-d procs
;Debug   Equ 1                    ; Debug define: "Anti-debugging?"
;NoCrypt Equ 1                    ; Debug define: "No encryption?"
Code     Segment Byte Public      ; Define our segment
Assume   Cs:Code,Ds:Code          ; Assume Cs and Ds our code
Org      100h                     ; The loader point for a com file
P386                              ; We want to use 386 instructions

  Include MACRO.INC               ; Macros for DS-CRYPT

 Start:                           ; The start of the code
  Mov    Dx,OffSet Intro          ; Our intro message
  EraseCode (Mark1-Start)        ; Erase the code from 100h to mark1
 Mark1   Equ $                    ; Marker number 1
  Call   Print                    ; Display the intro message
  GetParam                        ; Get commandline
  mov    [nmofs],dx
  OpenFile                        ; Open the file
  ReadBuf                         ; Read in the buf
  CalcSize                        ; Calculate the jmp size
  CheckExe                        ; Check for EXEs
  MakeRand                        ; Initialize random number gen
  WriteJmp                        ; Write a random jump
IFNDEF DEBUG                      ; Are we using debugging?
  Call   CreateKeys               ; Create Procedural_Crc_UpDate keys
  Call   EncodeNames              ; Encode the names for the loader
ENDIF                             ; End if statement
  EnCryptBuf                      ; Encrypt the buffer
  WriteBuf                        ; Write the buffer

  pusha
  lea    si,gencrc_s
  mov    cx,(Finish-gencrc_s)
  mov    dx,0DEEDh
  call   makecrc
  mov    word ptr [chgcrc],bx
  popa

  Call   MakeKeys                 ; Create the random number keys
  Lea    Di,Lp3                   ; The first part to encrypt
  Mov    Cx,(Finish-Lp3)          ; The size of this part
  Call   EncryptLoader            ; Encrypt the loader
  Lea    Di,Return                ; The second part to encrypt
  Mov    Cx,(Finish-Return)       ; The size
  Call   EncryptLoader            ; Encrypt the code
  Lea    Di,Decryptr              ; Encrypt the whole thing (3rd time)
  Mov    Cx,(Finish-There)        ; The size of it
  Call   EncryptLoader            ; Encrypt the loader randomly
  WriteLoader                     ; Write the loader
  mov    ax,4201h
  xor    cx,cx
  xor    dx,dx
  int    21h
  mov    [svv],dx
  mov    [svv+2],ax
  mov    ah,40h
  lea    dx,finish
  mov    cx,4
  int    21h
  MakeExtra                       ; Put random bytes into "Mutation" :)
  Call   CheckReg                 ; Check the registration stuff :)
  Call   WriteSig                 ; Write the signature
  mov    ah,3eh
  int    21h
  mov    ax,3d02h
  mov    dx,[nmofs]
  int    21h
  xchg   ax,bx
  mov    ax,4200h
  mov    cx,[svv]
  mov    dx,[svv+2]
  int    21h
  mov    ah,3fh
  mov    cx,5000
  lea    dx,buf
  int    21h
  push   ax
  sub    ax,4
  mov    word ptr [buf+2],ax
  pusha
  lea    si,buf+4
  mov    cx,ax
  mov    dx,0BEEDh
  call   makecrc
  mov    word ptr [buf],bx
  popa
  mov    ax,4200h
  mov    cx,[svv]
  mov    dx,[svv+2]
  int    21h
  pop    cx
  mov    ah,40h
  lea    dx,buf
  int    21h
  mov    ah,3eh
  int    21h

  Xor    Dx,Dx                    ; Zero Dx register
  Mov    Ax,LdrLen                ; The real loader len + mutations
  Add    Ax,5                     ; Account for the jump size
  Jmp    DispDec                  ; Display the loader size

 Include LOADER.INC
 Include DECRYPTR.INC
 Include PROCS.INC

makecrc proc
  xor  bx,bx
  xor  ax,ax
 scs2:
  lodsb
  add  bx,ax
  xor  bx,dx
  rol  bx,cl
  loop scs2
  ret
endp

  nmofs dw 0
  svv   dw 0,0

IFNDEF DEBUG
 OfsTab  Equ $           ; OffSet table for procedural_crc_update
    Dw   OffSet Mov1
    Dw   OffSet Mov2
    Dw   OffSet Mov3
    Dw   OffSet Mov4
    Dw   OffSet Mov5
    Dw   OffSet Mov6
    Dw   OffSet Mov7
    Dw   OffSet Mov8
    Dw   OffSet Mov9
    Dw   OffSet Mov10
    Dw   OffSet Mov11
    Dw   OffSet Mov12
    Dw   OffSet Mov13
    Dw   OffSet Mov14
ENDIF
  EndPos Dw 0
  TLen   Dw 0
  Usage  Db ' USAGE: DS-Crp <ComFile>$'
  Bufr   Db 4 Dup (0)
  Done   Db ' bytes',13,10,13,10,'Done!$'
  ExeMsg Db 'EXE files not supported!$'
  FnErr  Db 'File open error!$'
  FSize  Dw ?
  LdrLen Dw ?
  TmpLen Dw ?
  RorKey Db ?
  RolKey Db ?
  XorKey Db ?
  OutBuf Db 64+(Finish-Begin) Dup (?)
  Buf    Equ $
Code Ends

End Start